(function($){

	$(document).ready( function() {
		var o = {
			pageUrl        		: document.URL,
			pageTitle      		: document.title,
			pageDescription		: $('meta[name="description"]').attr('content'),
			siteTitle					: jpibfi_options.site_title,
			imageSelector			: jpibfi_options.image_selector,
			disabledClasses		: jpibfi_options.disabled_classes,
			enabledClasses		: jpibfi_options.enabled_classes,
			descriptionOption	: jpibfi_options.description_option,
			usePostUrl				: jpibfi_options.use_post_url == "1",
			minImageHeight		: jpibfi_options.min_image_height,
			minImageWidth			: jpibfi_options.min_image_width
		}

		var discriminatorClasses = o.disabledClasses.split(';');
		var allowedClasses = o.enabledClasses.split(';');

		$('.jpibfi').closest('div').addClass('jpibfi_container');

		$(o.imageSelector).each(function (i) {
			var e = $(this);

			//check if the image has a discriminator class, if has, then return
			if ( discriminatorClasses[0].length > 0 ) {
				for (var discriminatorClass in discriminatorClasses) {
					if (e.hasClass(discriminatorClasses[discriminatorClass]))
						return;
				}
			}
			//check allowed classes
			if ( allowedClasses[0].length > 0 ) {
				var hasAllowedClass = false;
				for (var z = 0; ( z < allowedClasses.length ) && !hasAllowedClass; z++ )
						hasAllowedClass = e.hasClass(allowedClasses[z]);

				if (!hasAllowedClass)
					return;
			}

			//to identify the image when loaded
			e.attr('data-indexer', i);
		});

		function jpibfiAddElements() {

			//selector = selector ? selector : "img[data-indexer]";
			var wpclasses = ['alignnone', 'alignright', 'alignleft'];

			$("img[data-indexer]").each(function () {
				var $image = $(this);

				if ( this.clientWidth < o.minImageWidth || this.clientHeight < o.minImageHeight ) {
					$image.removeAttr( 'data-indexer' );
					return;
				}

				var bookmarkUrl = "";
				if ( o.usePostUrl ) {
					var $inputWithUrl = $image.closest("div.jpibfi_container").children("input.jpibfi").first();
					if ($inputWithUrl.length != 0)
						bookmarkUrl = $inputWithUrl.attr("data-jpibfi-url");
				}
				if ( bookmarkUrl.length == 0 )
					bookmarkUrl = o.pageUrl;

				var bookmarkDescription;
				switch (o.descriptionOption) {
					case '3':
						bookmarkDescription = $image.attr('title') ? $image.attr('title') : $image.attr('alt');
						break;
					case '2':
						bookmarkDescription = o.pageDescription;
						break;
					case '4':
						bookmarkDescription = o.siteTitle;
						break;
				}
				if ( !bookmarkDescription )
						bookmarkDescription = o.pageTitle;

				var indexer = $image.attr("data-indexer"),
						bookmark = 'http://pinterest.com/pin/create/bookmarklet/?url=' + encodeURI(bookmarkUrl) + '&is_video=' + encodeURI('false') + '&description=' + encodeURI(bookmarkDescription);

				$image.wrap('<div class="pinit" data-indexer="' + indexer + '"/>');
				$image.after('<span class="pinit-overlay" data-indexer= "' + indexer + '"><a class="pinit-button" href="' + bookmark + '" data-indexer= "' + indexer + '">Pin It</a></span>');

				var $overlay = $('.pinit-overlay[data-indexer="' + indexer + '"]')
						.css({
							height         :this.clientHeight + 'px',
							width          :this.clientWidth + 'px',
							'margin-right' :$image.css('margin-right'),
							'margin-left'  :$image.css('margin-left'),
							'margin-top'   :$image.css('margin-top'),
							'margin-bottom':$image.css('margin-bottom')
						});

				for (var i in wpclasses) {
					if ( $image.hasClass(wpclasses[i]) ) {
						$('.pinit[data-indexer="' + indexer + '"]').addClass(wpclasses[i]);
						$overlay.addClass(wpclasses[i]);
					}
				}

				if ($image.hasClass('aligncenter')) {
					$('.pinit[data-indexer="' + indexer + '"]')
							.addClass('aligncenter')
							.css('clear', 'both');

					$overlay.css({
								'margin-left' :"auto",
								'margin-right':"auto",
								left          :0,
								right         :0
							})
				}

				$('.pinit .pinit-button').click( function () {
					var index = $(this).attr("data-indexer");
					var $image = $('img[data-indexer="' + index+ '"]');
					var imageUrl = $(this).attr('href') + "&media=" + encodeURI ( $image.data('media') ? $image.data('media') : $image[0].src );
					window.open(imageUrl, 'Pinterest', 'width=632,height=253,status=0,toolbar=0,menubar=0,location=1,scrollbars=1');
					return false;
				});

				$('.pinit').mouseenter(function () {
					$(this).children('.pinit-overlay').fadeIn(200);
				}).mouseleave(function () {
							$(this).children('.pinit-overlay').fadeOut(200);
				});
			})
		};

		function jpibfiRemoveElements() {
			$("span.pinit-overlay").remove();
			$("img[data-indexer]").unwrap();
		}

		$(window).load( jpibfiAddElements );

		$(window).resize ( function() {
			jpibfiRemoveElements();
			jpibfiAddElements();
		});

	})

})(jQuery);